//+------------------------------------------------------------------+
//|                                        VisualOpenOrderWithMM.mq4 |
//|                                                             Itso |
//|                                                      itso@dir.bg |
//+------------------------------------------------------------------+
#property copyright "Itso"
#property link      "itso@dir.bg"
#property show_inputs
#property strict
#include <stdlib.mqh>

extern double Risk = 0.05;

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----

   double MinLot = MarketInfo(Symbol(), MODE_MINLOT);
   double MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);
   double Step = MarketInfo(Symbol(), MODE_LOTSTEP);

   double StopLoss = WindowPriceOnDropped();
   double MoneyRisk = AccountFreeMargin() * Risk;
   double TickValue = MarketInfo(Symbol(), MODE_TICKVALUE);
   double MarginRequired = MarketInfo(Symbol(), MODE_MARGINREQUIRED);
   double FreeMargin = AccountFreeMargin();
   
   Print("MinLot: ", DoubleToStr(MinLot));
   Print("MaxLot: ", DoubleToStr(MaxLot));
   Print("Step: ", DoubleToStr(Step));
   Print("StopLoss: ", DoubleToStr(StopLoss));
   Print("MoneyRisk: ", DoubleToStr(MoneyRisk));
   Print("TickValue: ", DoubleToStr(TickValue));
   Print("MarginRequired: ", DoubleToStr(MarginRequired));
   Print("FreeMargin: ", DoubleToStr(FreeMargin));

   double PointLoss;
   int cmd;
   double price;
   if(Ask>StopLoss)
   {
      //Open Long
      PointLoss = (Ask - StopLoss) / Point;
      cmd = OP_BUY;
      price = Ask;
   }
   else
   {
      //Open Short
      PointLoss = (StopLoss - Bid) / Point;
      cmd = OP_SELL;
      price = Bid;
   }

   Print("PointLoss: ", DoubleToStr(PointLoss));
   Print("price: ", DoubleToStr(price));
   if(cmd == OP_BUY)
   {
      Print("OP_BUY");
   }
   else
   {
      Print("OP_SELL");
   }
   
   double LotsRough = MoneyRisk / (TickValue * PointLoss);
   
   Print("LotsRough: ", DoubleToStr(LotsRough));
   if(LotsRough<MinLot)
   {
      Print("Error. You don\'t have enough money!");
      return(0);
   }
   
   double Lots;
   double CheckedLot;
   if((MarginRequired * LotsRough) > FreeMargin)
   {
      Print("Use all the free margin for the operation!");
      Lots = MinLot;
      for(CheckedLot=MinLot; CheckedLot<=MaxLot; CheckedLot+=Step)
      {
         if((CheckedLot * MarginRequired) > FreeMargin)
         {
            Lots = CheckedLot - Step;
            break;
         }
      }
   }
   else
   {
      Print("If hit Stop Loss, the loss will be the risked one.");
      Lots = MaxLot;
      for(CheckedLot=MinLot; CheckedLot<=MaxLot; CheckedLot+=Step)
      {
         if(CheckedLot>LotsRough)
         {
            Lots = CheckedLot - Step;
            break;
         }
      }
   }
   
   Print("Lots: ", DoubleToStr(Lots));

   int ticket = OrderSend(Symbol(), cmd, Lots, price, 3, StopLoss, 0);
   if (ticket<0)
   {
      Print("Error: ", ErrorDescription(GetLastError()));
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+